<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: JSON sytax</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="page_References.html">References</a></li>  </ul>
</div>
</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">JSON sytax </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This sections describes the format of JSON, used for different settings of AS EWO</p>
<h1><a class="anchor" id="sec_RefJsonBasicConfig"></a>
Basic configuration</h1>
<p>The basic configuration is a string in JSON format, stored in dedicated <a class="el" href="page_RefDp.html#sec_RefDpBasicConfig">DP</a>. There is no WinCC OA panel for preparing the basic configuration, JSON string shall be prepared manually, using suitable text edidor. This section describes the syntax and semantics of basic configuration JSON.</p>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigStructure"></a>
The structure</h2>
<p>The whole basic configuration is rather large and complicated. Here are the major components of basic configuration (== top level nodes of JSON), the content of every component will be described in more details in next sections.</p>
<div class="fragment"><div class="line">{</div>
<div class="line">    &quot;ProxyModelConfiguration&quot;: {...},</div>
<div class="line">    &quot;FilterWidget&quot;: {...}.</div>
<div class="line">    &quot;MouseProcessor&quot;: {...},</div>
<div class="line">    &quot;EwoEventsProcessing&quot;: {...},</div>
<div class="line">    &quot;wildcards&quot;: {...},</div>
<div class="line">    &quot;SpecificOptions&quot;: {...},</div>
<div class="line">    &quot;UserSettings&quot;: {...}</div>
<div class="line">}</div>
</div><!-- fragment --><p>Only <b>ProxyModelConfiguration</b> is mandatory for basic configuration, all other parts are optional, though still useful.</p>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigModels"></a>
ProxyModelConfiguration</h2>
<p>Some basic knowledge of AS EWO code is needed in order to understand the configuration of models. The simplified structure of code in presented on the following picture:</p>
<div class="image">
<img src="models.png" alt=""/>
<div class="caption">
Software structure</div></div>
 <ul>
<li>
<b>Alarm Source</b> connects to live alarms in WinCC OA system or executes historical queries.  </li>
<li>
<b>Alarms Model</b> keeps the list of alarms, arriving from source.  </li>
<li>
<b>Proxy Model</b> performs filtering, sorting and grouping as specified by the user.  </li>
<li>
Finally, alarms data from Proxy Model are presented to user in <b>Alarm Table</b>.  </li>
</ul>
<p>Keeping this software structure in mind, the structure of model configuration looks more clear:</p>
<div class="fragment"><div class="line">&quot;ProxyModelConfiguration&quot;: {</div>
<div class="line">    &quot;AlarmModelConfiguration&quot;: {...},</div>
<div class="line">    &quot;columns&quot;: [...]</div>
<div class="line">    }</div>
</div><!-- fragment --><p>The ProxyModelConfiguration consists of the source for Proxy Model (<b>AlarmModelConfiguration</b>, the configuration for Alarm Model, according to software strcture), and list of columns which can be shown in table.</p>
<h3><a class="anchor" id="subsubsec_RefJsonBasicConfigAlarmModel"></a>
AlarmModelConfiguration</h3>
<p>The configuration for Alarm Model, in turn, includes the <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmSource">configuration</a> for Alarm Source,</p>
<div class="fragment"><div class="line">&quot;AlarmModelConfiguration&quot;: {</div>
<div class="line">    &quot;AlarmSourceConfiguration&quot;: {</div>
<div class="line">        ...</div>
<div class="line">        },</div>
<div class="line">    &quot;blockingTime&quot;: 2000,</div>
<div class="line">    &quot;embeddedFilters&quot;: {</div>
<div class="line">        }</div>
<div class="line">}</div>
</div><!-- fragment --><p>The items for <b>AlarmModelConfiguration</b> are the following: </p><ul>
<li>
<b>AlarmSourceConfiguration</b>: see <a class="el" href="page_RefJson.html#subsubsec_RefJsonBasicConfigAlarmSource">AlarmSourceConfiguration</a> for more details </li>
<li>
<b>blockingTime</b>: the time in milliseconds between successive updates of Alarm Model with new data from Alarm Source. The main purpose of this delay is to avoid continuous refresh of Alarm Table if new alarm data arrive to source continuously: the table content is not updated during this time interval, new alarms data are buffered, and then, after blocking time expires, all collected alarm data are processed in one batch.  </li>
<li>
<b>embeddedFilters</b>: sometimes the required filtering can't be expressed as FROM and/or WHERE clauses of <code>dpQueryConnectSingle()</code>, but the list of alarms for Alarm Model still needs to be filtered. In such case, a definition of structured filter (see <a class="el" href="pageUsingAS.html#subSecStructuredFilter">Structured filters (entered using widgets)</a>) can be added here, and only alarms matching this filter will reach the Alarm Model from Alarm Source.  </li>
</ul>
<h3><a class="anchor" id="subsubsec_RefJsonBasicConfigColumns"></a>
columns</h3>
<p>The <code>columns</code> entry of configuration for Alarm Model describes all columns which can be shown in table. The <b>columns</b> is an array of objects, where every object describes individual column.</p>
<div class="fragment"><div class="line">&quot;columns&quot;: [</div>
<div class="line">    { &quot;id&quot;: &quot;Abbreviation&quot;, &quot;source&quot;: &quot;this&quot;, &quot;title&quot;: &quot;Short Sign&quot;, &quot;backColor&quot;: { &quot;id&quot;: &quot;AlertColor&quot; } },</div>
<div class="line">    { &quot;id&quot;: &quot;AlarmTime&quot;, &quot;title&quot;: &quot;Local Time&quot; },</div>
<div class="line">    { &quot;id&quot;: &quot;timeUtc&quot;, &quot;title&quot;: &quot;UTC Time&quot; },</div>
<div class="line">    ...</div>
<div class="line">]</div>
</div><!-- fragment --><p>Every column object may contain the following items: </p><ul>
<li>
<b>id</b> (mandatory): the internal name of alarm property to be shown in this column, see <a class="el" href="page_AlarmProp.html">Alarm properties</a>.  </li>
<li>
<b>source</b> (optional): the source for reading this property, possible values are: <ul>
<li>
<b>this</b>: the value of alarm property property for this column is taken from 'this' alarm, i.e. the alarm which is displayed in table row  </li>
<li>
<b>partner</b>: the value of alarm property for this column is taken from partner of the alarm which is displayed in table row  </li>
<li>
<b>came</b>: the value of alarm property for this column is taken from CAME alarm of alarms pair  </li>
<li>
<b>went</b>: the value of alarm property for this column is taken from WENT alarm of alarms pair  </li>
</ul>
If <b>source</b> is missing in column configuration, then <b>this</b> is assumed.  </li>
<li>
<b>title</b> (mandatory): the string with header of column as it shall appear in Alarm Table. Note that this title is not only for displayin in the table header, for example, user settings related to columns will operate the <b>title</b> given here.  </li>
<li>
<b>hideable</b> (optional): <code>false</code> if user shall not be allowed to hide this column in Alarm Table; default is <code>true</code>. <dl class="section note"><dt>Note</dt><dd>even for columns which are not hideable, user can reduce visible column width to zero  </dd></dl>
</li>
<li>
<b>backColor</b> (optional): the decsription of other alarm property where background color for this column shall be taken.  </li>
<li>
<b>foreColor</b> (optional): the decsription of other alarm property where foreground (text) color for this column shall be taken.  </li>
</ul>
<p>The content of <b>backColor</b> and <b>foreColor</b> are, in principle, objects of the same structure, but only <b>id</b> and <b>source</b> values are used.</p>
<h3><a class="anchor" id="subsubsec_RefJsonBasicConfigAlarmSource"></a>
AlarmSourceConfiguration</h3>
<p>The configuration for Alarm Source has the following structure:</p>
<div class="fragment"><div class="line">&quot;AlarmSourceConfiguration&quot;: {</div>
<div class="line">    &quot;fromTemplate&quot;: &quot;&quot;,</div>
<div class="line">    &quot;whereTemplate&quot; : &quot;&quot;,</div>
<div class="line">    &quot;maxThreadCount&quot;: 1,</div>
<div class="line">    &quot;maxWaitForDpGet&quot;: 10,</div>
<div class="line">    &quot;autoConnectSystems&quot;: [</div>
<div class="line">        &quot;system1&quot;,</div>
<div class="line">        &quot;system2*&quot;</div>
<div class="line">        ],</div>
<div class="line">    &quot;plugins&quot;: [</div>
<div class="line">        {</div>
<div class="line">            &quot;name&quot;: &quot;AlarmSourceJCOP&quot;,</div>
<div class="line">            &quot;options&quot;: {</div>
<div class="line">                &quot;descriptionWhenEmpty&quot;: &quot;aliasOrName&quot;</div>
<div class="line">                }</div>
<div class="line">        },</div>
<div class="line">        &quot;AlarmSourceUNICOS&quot;</div>
<div class="line">        ]</div>
<div class="line">    }</div>
</div><!-- fragment --><p>The configuration for source may include the following parts (all are optionsl): </p><ul>
<li>
<b>fromTemplate</b>: the string, containing template for FROM clause of query, passed to <code>dpQueryConnectSingle()</code> call. This can be used to reduce the amount of alarms, arrived to Alarm Source. Example if configuration for UNICOS where input is restricted to only DPs with paricular structure: <div class="fragment"><div class="line">&quot;fromTemplate&quot;: &quot;FROM &#39;*.ProcessInput.*&#39;&quot;</div>
</div><!-- fragment -->  </li>
<li>
<b>whereTemplate</b>: the string, containing template for FROM clause of query, passed to <code>dpQueryConnectSingle()</code> call. This can be used to reduce the amount of alarms, arrived to Alarm Source.  </li>
<li>
<b>maxThreadCount</b>: maximum number of threads which can be used for processing callback data in <b>Online</b> mode of alarm source. Default value is 1. Zero or negative value means that alarm source shall take the default number for Qt (calculated from number of processor cores).  </li>
<li>
<b>maxWaitForDpGet</b>: maximum number to wait for response of dpGet() call in <b>Archive</b> mode of alarm source. Default value is 10. Filtering on some of alarm properties can't be directly mapped to criteria in query for archive DB; examples can be found in UNICOS: <b>alarmType</b> and <b>master</b> properties of alarms: for some DP types these properties are calculated from content of special DPE <b>*.statusInformation.configuration.deviceConfiguration</b>, whose value is not available in archive (in general). Filtering on such properties is done in two steps: <ol>
<li>
Query uses only part of the whole criteria, if possible (for example, criteria on DP type names)  </li>
<li>
Then for alarms, returned by query, the 'final filtering' to be applied, requiring the value of DPE to be obtained by dpGet() call.  </li>
</ol>
If the response for dpGet() request doesn't arrive after waiting for number of seconds, given by this value, then the query of archived data is considered to be failed.  </li>
<li>
<b>autoConnectSystems</b>: array of system names to which AS EWO shall connect automatically. The names can contain UNIX-style wildcards.  </li>
<li>
<p class="startli"><b>plugins</b>: the array of plugins, used to extend set of properties for alarm, see <a class="el" href="page_AlarmProp.html">Alarm properties</a>. Alarm Source may use more than one plugin, they are processed in the order in which they appear in this array; the next plugin may override properties calculated by prevous plugin.<br  />
 The same plugins also provide functionality of building query for archived data, as well as processing query results. Again, the 'most important' plugin must be the last one in this list.<br  />
</p>
<p class="endli">Two types of format for elements of plugins array are supported: </p><ul>
<li>
<b>object</b>: plugin definition is object containing two items: <ul>
<li>
<b>name</b>: the name of plugin to be loaded (in fact - the name of DLL/so)  </li>
<li>
<b>options</b>: the set of options for this plugin. The options are interpreted by plugin itself, the AS EWO doesn't make any assumptions on syntax/semantics of options. The format for plugin options is the same as for <a class="el" href="page_RefJson.html#subsect_RefJsonBasicConfigSpecificOptions">SpecificOptions</a>.<br  />
 For the time being the only plugin working with options is AlarmPropJCOP plugin; it can use option named <b>descriptionWhenEmpty</b>. This option determines what shall be the content of <b>Description</b> property when description itself is missing. Possible values are: <ul>
<li>
<b>deviceName</b>: device name shall be used if description is empty  </li>
<li>
<b>aliasOrName</b>: alias shall be used if description is empty; if alias is also empty then device name shall be used  </li>
</ul>
</li>
</ul>
</li>
<li>
<b>string</b>: plugin definition only contains plugin name to be loaded, without any options.  </li>
</ul>
<p>Both varaints are shown in the example JSON above: <b>object</b> for AlarmPropJCOP and <b>string</b> for AlarmPropUNICOS.<br  />
  While building the query for historical data from ORACLE RDB, the main purpose of such plugins is preparing WHERE clause of query according to content of filter, supplied by user. There is a default processing, that can prepare query predicates for 'standard' alarm properties. But if some of these plugins, has introduced new (framework-specifc) alarm property, then basic implementation just doesn't know how to convert user filter on this property to ORACLE query. The plugins, listed in this section, are expected to know how to convert filter to ORACLE query for specific framework (if that is possible at all).  </p>
</li>
</ul>
<p>Both <b>fromTemplate</b> and <b>whereTemplate</b> may not only be fixed strings, they can be parametrized strings, with values of parameters applied at run time. For example, if we want AS EWO to display alarms of one DP only, then we can specify in configuration something like: </p><div class="fragment"><div class="line">&quot;whereTemplate&quot; : &quot;WHERE _DP = \&quot;%1\&quot;&quot;</div>
</div><!-- fragment --><p>Then at run time real DP name can be substituted to string template using corresponding EWO <a class="el" href="page_RefEwo.html#sec_RefEwoMethodsFilterParam">methods</a>.</p>
<p>Parameters in string shall be called <b>%1</b>, <b>%2</b> etc. Lists of strings, passed to EWO <a class="el" href="page_RefEwo.html#sec_RefEwoMethodsFilterParam">methods</a>, shall contain enough items to substitute all parameters.</p>
<p>In either case, AS EWO doesn't make any check on syntax of resulting FROM and WHERE to be used in query: the query either works or not. Even if it works (i.e. there is no syntax error), it can happen that result of query is not what was planned. The right query syntax is responsability of user who prepared configuration, the right values for parameters substitution is a responsability of CTRL that passes strings for parameters substitution.</p>
<p>Furthermore, the format of FROM and WHERE parts of query are expected to be different for different modes of data source (online data, or archived data). The examples above assumed online source of alarms, where syntax must be suitable for passing resulting string to <code>dpQueryConnectSingle()</code> and similar functions.</p>
<p>For data from archive, syntax of FROM and WHERE shall be different. Even more, the syntax can also depend on what archiving is used. In order to allow source switching on the fly, the syntax allows one more form of configuration for <b>fromTemplate</b> and <b>whereTemplate</b>:</p>
<div class="fragment"><div class="line">&quot;whereTemplate&quot;: {</div>
<div class="line">    &quot;online&quot;: &quot;WHERE _DP = \&quot;%1\&quot;&quot;,</div>
<div class="line">    &quot;oracleRDB&quot;: &quot;(el.element_name LIKE &#39;%2.%&#39;)&quot;</div>
<div class="line">}</div>
</div><!-- fragment --><p>In this example, two variants of WHERE condition for query are specified in configuration: one for online alarm source, and another one for alarm source, reading archived alarms from ORACLE RDB.</p>
<dl class="section note"><dt>Note</dt><dd>The same syntax of configuration can be used for <b>fromTemplate</b>, but for the time being FROM is not used for data from ORACLE RDB.</dd></dl>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigFilterWidget"></a>
FilterWidget</h2>
<p>The basic AS EWO does <b>not</b> include any particular configuration for structured filter (see <a class="el" href="pageUsingAS.html#subSecStructuredFilter">Structured filters (entered using widgets)</a>). Instead, AS EWO can load at run time dedicted plugin, which is responsible for bulding the structured filter area, using standard filter widgets implemented in AS EWO.</p>
<p>The <b>FilterWidget</b> part of basic configuration has the following structure (example of configuration for JCOP):</p>
<div class="fragment"><div class="line">&quot;FilterWidget&quot;: {</div>
<div class="line">    &quot;widgetBuilder&quot;: &quot;FilterWidgetJCOP&quot;,</div>
<div class="line">    &quot;completerLib&quot;: &quot;fwAlarmScreenNg/AlarmScreenJCOP.ctl&quot;,</div>
<div class="line">    &quot;masterCompleterFunc&quot;: &quot;AlarmScreenJCOP_getFilterCompletions&quot;,</div>
<div class="line">    &quot;slaveCompleterFunc&quot;: &quot;AlarmScreenJCOP_getSlaveFilterCompletions&quot;</div>
<div class="line">}</div>
</div><!-- fragment --><p>All parts of this configuration are optional: AS EWO may operate without editable structured filter.</p>
<ul>
<li>
<b>widgetBuilder</b>: the name of plugin which shall build all necessary widgets for editing structured filter.  </li>
<li>
<b>completerLib</b>: the name of CTRL library, containing functions for calculating list of possible completions for every filter widget. See <a class="el" href="page_RefFilterCompleters.html">Filter completers</a>  </li>
<li>
<b>masterCompleterFunc</b>: the name of CTRL function to ba called for calculating list of possible completions for filter widgets where list of completions does not depend on current value in another filter widget. See <a class="el" href="page_RefFilterCompleters.html">Filter completers</a>  </li>
<li>
<b>slaveCompleterFunc</b>: the name of CTRL function to ba called for calculating list of possible completions for filter widgets where list of completions depends on current value in another filter widget, i.e. this filter is a slave for another filter. See <a class="el" href="page_RefFilterCompleters.html">Filter completers</a>  </li>
</ul>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigMouseProc"></a>
MouseProcessor</h2>
<p>This part of basic configuration is almost useless, though still needed if mouse events from Alarm Table need to be processed.</p>
<div class="fragment"><div class="line">&quot;MouseProcessor&quot;: {</div>
<div class="line">    &quot;processByEwo&quot;: true,</div>
<div class="line">    &quot;ctrlLib&quot;: &quot;fwAlarmScreenNg/AlarmScreenJCOP.ctl&quot;,</div>
<div class="line">    &quot;ctrlFunc&quot;: &quot;AlarmScreenJCOP_mouseTableEvent&quot;</div>
<div class="line">}</div>
</div><!-- fragment --><ul>
<li>
<b>processByEwo</b>: the value must be <code>true</code>, in this case mouse events is fired as event of AS EWO and processed by CTRL code. Other option (<code>false</code>) doesn't work as expected, so it shall not be used.  </li>
<li>
<b>ctrlLib</b>: not ised if <b>processByEwo</b> is <code>true</code>  </li>
<li>
<b>ctrlLib</b>: not ised if <b>processByEwo</b> is <code>true</code>  </li>
</ul>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigEwoEvents"></a>
EwoEventsProcessing</h2>
<p>Description of <a class="el" href="page_RefEwo.html#sec_RefEwoEvents">AS EWO events</a> mentioned that names of CTRL function for processing this event and CTRL library where that function is dfined are passed in arguments to EWO events. But how EWO can know these names? No magic, the names are just part of basic configuration, as shown in the next example for JCOP configuration:</p>
<div class="fragment"><div class="line">&quot;EwoEventsProcessing&quot;: {</div>
<div class="line">    &quot;mouseEvent&quot;: {</div>
<div class="line">        &quot;ctrlLib&quot;: &quot;fwAlarmScreenNg/AlarmScreenJCOP.ctl&quot;,</div>
<div class="line">        &quot;ctrlFunc&quot;: &quot;AlarmScreenJCOP_mouseTableEvent&quot;</div>
<div class="line">        },</div>
<div class="line">    &quot;ctrlActionRequested&quot;: {</div>
<div class="line">        &quot;ctrlLib&quot;: &quot;fwAlarmScreenNg/AlarmScreenJCOP.ctl&quot;,</div>
<div class="line">        &quot;ctrlFunc&quot;: &quot;AlarmScreenJCOP_ctrlActionRequested&quot;</div>
<div class="line">        }</div>
<div class="line">}</div>
</div><!-- fragment --><p>When AS EWO is about to fire event, it just takes these names from basic configuration and adds them to the arguments of event. The names are not interpreted in any way by EWO itself.</p>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigWildcards"></a>
wildcards</h2>
<p>In some cases 'unusual' wildcards are used, and basic configuration allows to modify some settings for interpretaion of wildcards in AS EWO.</p>
<div class="fragment"><div class="line">&quot;wildcards&quot;: {</div>
<div class="line">    &quot;matchZeroOrMoreChars&quot;: &quot;%&quot;,</div>
<div class="line">    &quot;matchSingleChar&quot;: &quot;_&quot;,</div>
<div class="line">    &quot;alwaysShowNonEmpty&quot;: true</div>
<div class="line">}</div>
</div><!-- fragment --><ul>
<li>
<b>matchZeroOrMoreChars</b>: specifieis the character that matches zero or more characters. The default value is '<b>*</b>' (asterisk).  </li>
<li>
<b>matchSingleChar</b>: specifies the character that matches any single character. The default value is '<b>?</b>' (question mark).  </li>
<li>
<b>alwaysShowNonEmpty</b>: normally 'no filter' is indicated by empty string in individual filters. When this value is set to <code>true</code>, 'no filter' is indicated by <b>matchZeroOrMoreChars</b> character.  </li>
</ul>
<h2><a class="anchor" id="subsect_RefJsonBasicConfigSpecificOptions"></a>
SpecificOptions</h2>
<p>This is rather special section in basic settings, it may contain arbitrary settings which are not even interpreted/used by basic implementation of AS EWO. For the moment JCOP-specific extension uses one setting of this category:</p>
<div class="fragment"><div class="line">&quot;SpecificOptions&quot;: {</div>
<div class="line">    &quot;maskWithForceFiltered&quot;: {</div>
<div class="line">        &quot;enabled&quot;: true</div>
<div class="line">    }</div>
<div class="line">}</div>
</div><!-- fragment --><p>This is used to control appearance of <b>mask Alarm</b> item in <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">popup menu</a>: when this option is missing in basic config, or when the value of <b>enabled</b> is <code>false</code>, then the item just does not appear in popup menu.</p>
<p>But configuraion allows specifying any option, required to configure any feature (extenstion) of AS EWO. For example, this section could like like the following when two more specific options have been added:</p>
<div class="fragment"><div class="line">&quot;SpecificOptions&quot;: {</div>
<div class="line">    &quot;maskWithForceFiltered&quot;: {</div>
<div class="line">        &quot;enabled&quot;: true</div>
<div class="line">            },</div>
<div class="line">    &quot;someOption1&quot;: {</div>
<div class="line">        &quot;userlabel&quot;: &quot;The label for option #1&quot;,</div>
<div class="line">        &quot;threshold&quot;: 234,</div>
<div class="line">        &quot;enabled&quot;: true,</div>
<div class="line">        &quot;values&quot;: [</div>
<div class="line">            123,</div>
<div class="line">            234,</div>
<div class="line">            345</div>
<div class="line">            ]</div>
<div class="line">        },</div>
<div class="line">    &quot;someOption2&quot;: {</div>
<div class="line">        &quot;alwaysVisible&quot;: false,</div>
<div class="line">        &quot;choices&quot;: [</div>
<div class="line">            { &quot;label&quot;: &quot;one&quot;, &quot;value&quot;: 1 },</div>
<div class="line">            { &quot;label&quot;: &quot;two&quot;, &quot;value&quot;: 2 }</div>
<div class="line">            ]</div>
<div class="line">        }</div>
<div class="line">    }</div>
</div><!-- fragment --><p>Every single option must have a unique name, the value for option must be object with arbitrary structure. CTRL code may retrive the value of option with given ID (name) using dedicated <a class="el" href="page_RefEwo.html#sec_refEwoMethodsSpecificOptions">method</a> of AS EWO.</p>
<h2><a class="anchor" id="subsec_RefJsonBasicConfigDefaults"></a>
Default UserSettings</h2>
<p>In addition to configuration items, described in previous sections, basic configuration also contain default user settings for AS EWO. At run time these settings can be changed by user, the settings in basic configuration is just a default.</p>
<p>The format is for user settings is described in <a class="el" href="page_RefJson.html#subsec_RefJsonUserSettings">User settings</a>.</p>
<h1><a class="anchor" id="sec_RefJsonOther"></a>
Other</h1>
<p>Unlike basic configuration, which must be prepared manually, other settings can be edited using dedicated panels. Normally, the user (or admin) shall not care about the JSON format for these settings. In addition, it is simple enough to make minor reverse engineering: just save required subset of settings, then look at resulting JSON, written to correspodning <a class="el" href="page_RefDp.html">DP</a>. This part of document provides just very short format description for these settings.</p>
<h2><a class="anchor" id="subsec_RefJsonAdminSettings"></a>
Admin Settings</h2>
<p>There are 3 subsets of admin settings, described in <a class="el" href="page_ConfigAdmin.html">Admin Settings</a>, they are stored in 3 DPEs of dedicated <a class="el" href="page_RefDp.html#sec_RefDpAdminSettings">DP </a>. Every subset of admin settings uses its own format.</p>
<h3><a class="anchor" id="subsubsec_RefJsonAdminAccess"></a>
Access control</h3>
<p>The settings of access control are normally edited using dedicated <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">panel</a> and finally saved in DPE of dedicated <a class="el" href="page_RefDp.html#sec_RefDpAdminSettings">DP</a>. The format of access control settings is the following:</p>
<div class="fragment"><div class="line">{</div>
<div class="line">    &quot;ackAll&quot;: [</div>
<div class="line">            {</div>
<div class="line">                &quot;domain&quot;: &quot;DCS&quot;,</div>
<div class="line">                &quot;privilege&quot;: &quot;expert&quot;</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;other&quot;: 2</div>
<div class="line">            }</div>
<div class="line">        ],</div>
<div class="line">    &quot;ackGone&quot;: [</div>
<div class="line">            {</div>
<div class="line">                &quot;domain&quot;: &quot;RICH&quot;,</div>
<div class="line">                &quot;privilege&quot;: &quot;expert&quot;</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;domain&quot;: &quot;CHOD&quot;,</div>
<div class="line">                &quot;privilege&quot;: &quot;expert&quot;</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;other&quot;: 1</div>
<div class="line">            }</div>
<div class="line">        ]</div>
<div class="line">}</div>
</div><!-- fragment --><p>The syntax of JSON seems to be evident when comparing with the functionality of <a class="el" href="page_ConfigAdmin.html#sec_AccessControl">panel</a> used for editing access control rules: the names of <a class="el" href="page_RefActions.html">actions</a> having some restrictions, plus the details of restrictions for every action.</p>
<h3><a class="anchor" id="subsubsec_RefJsonAdminMenu"></a>
Popup menu configuratin</h3>
<p>The content of popup menu for alarm table is edited using dedicated <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">panel</a> and finally saved in DPE of dedicated <a class="el" href="page_RefDp.html#sec_RefDpAdminSettings">DP</a>. The format of popup menu descriiption is the following (part of configuration for JCOP):</p>
<div class="fragment"><div class="line">[</div>
<div class="line">    {</div>
<div class="line">        &quot;action&quot;: &quot;viewAlarmTrend&quot;,</div>
<div class="line">        &quot;appearanceFunc&quot;: &quot;AlarmScreenMenuJCOP_itemAppearance&quot;,</div>
<div class="line">        &quot;appearanceLib&quot;: &quot;AlarmScreenNg/AlarmScreenMenuJCOP.ctl&quot;,</div>
<div class="line">        &quot;ctrlFunc&quot;: &quot;AlarmScreenMenuJCOP_showTrend&quot;,</div>
<div class="line">        &quot;ctrlLib&quot;: &quot;AlarmScreenNg/AlarmScreenMenuJCOP.ctl&quot;,</div>
<div class="line">        &quot;label&quot;: &quot;Trend&quot;</div>
<div class="line">    },</div>
<div class="line">    ...</div>
<div class="line">]</div>
</div><!-- fragment --><p>The syntax of JSON seems to be evident when comparing with the functionality of <a class="el" href="page_ConfigAdmin.html#sec_AdminPopupMenu">panel</a> used for editing popup menu: array of objects, where every object contains details for every menu item.</p>
<h3><a class="anchor" id="subsebsec_RefJsonAdminHelpFile"></a>
Help file types</h3>
<p>Supported help file types are edited using dedicated <a class="el" href="page_ConfigAdmin.html#sec_HelpFileTypes">panel</a> and finally saved in DPE of dedicated <a class="el" href="page_RefDp.html#sec_RefDpAdminSettings">DP</a>. The format of help file types description is the following (part of default configuration):</p>
<div class="fragment"><div class="line">{</div>
<div class="line">    &quot;.htm&quot;: {</div>
<div class="line">        &quot;cmdLinux&quot;: &quot;&quot;,</div>
<div class="line">        &quot;cmdWin&quot;: &quot;&quot;</div>
<div class="line">        },</div>
<div class="line">    &quot;.html&quot;: {</div>
<div class="line">        &quot;cmdLinux&quot;: &quot;&quot;,</div>
<div class="line">        &quot;cmdWin&quot;: &quot;&quot;</div>
<div class="line">        },</div>
<div class="line">        ...</div>
<div class="line">}</div>
</div><!-- fragment --><p>JSON contains all supported types of help files, plus two commands for opening files of this type on different operating systems.</p>
<h2><a class="anchor" id="subsec_RefJsonUserSettings"></a>
User settings</h2>
<p>User settings are edited using dedicated <a class="el" href="page_UserSettings.html#sec_EditUserSettings">panel</a> and finally saved in DPE of dedicated <a class="el" href="page_RefDp.html#sec_RefDpUserSettings">DP</a>. The format of user settings is the following:</p>
<div class="fragment"><div class="line">{</div>
<div class="line">    &quot;GroupingConfiguration&quot;: {</div>
<div class="line">        &quot;columnWidth&quot;: 150,</div>
<div class="line">        &quot;groupHeader&quot;: &quot;System / Priority&quot;,</div>
<div class="line">        &quot;groupingRules&quot;: [</div>
<div class="line">                {</div>
<div class="line">                    &quot;alarmPropId&quot;: &quot;SystemName&quot;,</div>
<div class="line">                    &quot;groupingRole&quot;: &quot;display&quot;,</div>
<div class="line">                    &quot;sortAscending&quot;: true,</div>
<div class="line">                    &quot;textFormat&quot;: &quot;&quot;</div>
<div class="line">                },</div>
<div class="line">                {</div>
<div class="line">                    &quot;alarmPropId&quot;: &quot;Priority&quot;,</div>
<div class="line">                    &quot;groupingRole&quot;: &quot;display&quot;,</div>
<div class="line">                    &quot;sortAscending&quot;: false,</div>
<div class="line">                    &quot;textFormat&quot;: &quot;&quot;</div>
<div class="line">                }</div>
<div class="line">            ]</div>
<div class="line">        },</div>
<div class="line">    &quot;allowSwitchPairMode&quot;: true,</div>
<div class="line">    &quot;filterSetDp&quot;: &quot;na62dcs01:_NgAsFilterSet_1&quot;,</div>
<div class="line">    &quot;showFilterView&quot;: &quot;top&quot;,</div>
<div class="line">    &quot;showFilterWidget&quot;: true,</div>
<div class="line">    &quot;showFooterWidget&quot;: true,</div>
<div class="line">    &quot;singleRowPerPair&quot;: true,</div>
<div class="line">    &quot;showConnectMap&quot;: false,</div>
<div class="line">    &quot;useSystemConnectDialog&quot;: false,</div>
<div class="line">    &quot;tableFont&quot;: &quot;Arial,-1,12,5,50,0,0,0,0,0&quot;,</div>
<div class="line">    &quot;sortingOrder&quot;: [</div>
<div class="line">            {</div>
<div class="line">                &quot;columnTitle&quot;: &quot;Time&quot;,</div>
<div class="line">                &quot;sortAscending&quot;: false</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;columnTitle&quot;: &quot;Ack.&quot;,</div>
<div class="line">                &quot;sortAscending&quot;: true</div>
<div class="line">            }</div>
<div class="line">        ],</div>
<div class="line">    &quot;visibleColumns&quot;: [</div>
<div class="line">            {</div>
<div class="line">                &quot;columnTitle&quot;: &quot;Short Sign&quot;,</div>
<div class="line">                &quot;visible&quot;: &quot;always&quot;,</div>
<div class="line">                &quot;width&quot;: 40</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;columnTitle&quot;: &quot;Device DP Element&quot;,</div>
<div class="line">                &quot;visible&quot;: &quot;never&quot;,</div>
<div class="line">                &quot;width&quot;: 350</div>
<div class="line">            },</div>
<div class="line">            ...</div>
<div class="line">        ],</div>
<div class="line">    &quot;defaultFilter&quot;: {...}</div>
<div class="line">}</div>
</div><!-- fragment --><p>Again, the sybtax of JSON seems to be evident when comparing with content of <a class="el" href="page_UserSettings.html#sec_EditUserSettings">panel</a> used for editing user settings.</p>
<p>Sitting a bit aside is a <b>defaultFilter</b>. The content of this section contains the definition of structured filter at moment when user settings were saved. However, the definition of how this <b>defaultFilter</b> shall be used when loading this settings - is not part of user settings themselves, the usage is defined by content of <b>DefaultFilter</b> DPE, see <a class="el" href="page_RefDp.html#sec_RefDpUserSettings">User settings</a>.</p>
<h2><a class="anchor" id="subsec_RefJsonFilter"></a>
Filter</h2>
<p>The structured filter, edited in filter editor area of EWO (see <a class="el" href="pageUsingAS.html#subSecStructuredFilter">Structured filters (entered using widgets)</a>) can be saved in DPE of dedicated <a class="el" href="page_RefDp.html#sec_RefDpFilter">DP</a>. Exact content of JSON with filter settings depends on content of individual filters in filter editor. JSON below illustrates common structure of filter syntax in JSON:</p>
<div class="fragment"><div class="line">{</div>
<div class="line">    &quot;matchCase&quot;: false,</div>
<div class="line">    &quot;filterRulesSets&quot;: [</div>
<div class="line">        {</div>
<div class="line">            &quot;include&quot;: true,</div>
<div class="line">            &quot;filters&quot;: [</div>
<div class="line">                {</div>
<div class="line">                    &quot;filter&quot;: {</div>
<div class="line">                        &quot;pattern&quot;: &quot;na62dcs01*&quot;,</div>
<div class="line">                        &quot;source&quot;: &quot;this&quot;,</div>
<div class="line">                        &quot;valueId&quot;: &quot;dpElement&quot;</div>
<div class="line">                        }</div>
<div class="line">                },</div>
<div class="line">                {</div>
<div class="line">                    &quot;fixedMultiFilter&quot;: [</div>
<div class="line">                        {</div>
<div class="line">                            &quot;fixedFilter&quot;: {</div>
<div class="line">                                &quot;filter&quot;: {</div>
<div class="line">                                    &quot;numbers&quot;: &quot;1,40-59&quot;,</div>
<div class="line">                                    &quot;source&quot;: &quot;this&quot;,</div>
<div class="line">                                    &quot;valueId&quot;: &quot;Priority&quot;</div>
<div class="line">                                    },</div>
<div class="line">                                    &quot;include&quot;: true,</div>
<div class="line">                                    &quot;kind&quot;: &quot;severityWarning&quot;</div>
<div class="line">                                    }</div>
<div class="line">                        },</div>
<div class="line">                        ...</div>
<div class="line">                    ]</div>
<div class="line">                }</div>
<div class="line">            ],</div>
<div class="line">        }</div>
<div class="line">    ]</div>
<div class="line">}</div>
</div><!-- fragment --><p>The definition of structured filter consista of two elements: </p><ul>
<li>
<b>matchCase</b>: flag indicating if filter shall use case-sensitive string comparison  </li>
<li>
<b>filterRulesSets</b>: array of objects, every such object corresponds to one tab on structured filter editor. Every 'filter set' (or 'filter tab') object again consists of two elements: <ul>
<li>
<b>include</b>: flag indicating if alarms matching this set of filters shall be included to or excluded from visible table  </li>
<li>
<b>filters</b>: array of objects, every object corresponds to individual filter on this tab of filter editor. The structure of every individual filter depends on type of widget, used for editing this filter. Independently on widget type, all individual filters have two common fields: <ul>
<li>
<b>valueId</b>: the name of alarm <a class="el" href="page_AlarmProp.html">property</a>, whose value is taken for comparing with filter condition.  </li>
<li>
<b>source</b>: from which alarm given alarm property shall be taken (this, partner, came, went).  </li>
</ul>
Other field(s) for individual filter are filter type dependent. If there is a need for creating manually the filter in JSON, then the easy way is to specify required filter in filter editor area of EWO, save that filter and look at resulting JSON, written to DPE.<br  />
 There is also a method in AS EWO, allowing to read JSON presentation of current filter in EWO, see the <a class="el" href="page_RefEwo.html#sec_RefEwoMethodsOther">methods</a> of AS EWO.  </li>
</ul>
</li>
</ul>
<h2><a class="anchor" id="subsec_RefJsonFilterSet"></a>
Filter View</h2>
<p>The content and appearance of filter view, edited in dedicated <a class="el" href="page_FilterViewEditor.html">panel</a>, is saved in DPE of dedicated <a class="el" href="page_RefDp.html#sec_RefDpFilterView">DP</a>. The structure of JSON with filter view definition is the following:</p>
<div class="fragment"><div class="line">{</div>
<div class="line">    &quot;grid&quot;: {</div>
<div class="line">        &quot;filters&quot;: [</div>
<div class="line">            {</div>
<div class="line">                &quot;column&quot;: 0,</div>
<div class="line">                &quot;filterDp&quot;: &quot;_NgAsFilter_operator_1&quot;,</div>
<div class="line">                &quot;row&quot;: 0</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;column&quot;: 1,</div>
<div class="line">                &quot;filterDp&quot;: &quot;_NgAsFilter_operator_2&quot;,</div>
<div class="line">                &quot;row&quot;: 0</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;column&quot;: 2,</div>
<div class="line">                &quot;filterDp&quot;: &quot;_NgAsFilter_operator_3&quot;,</div>
<div class="line">                &quot;row&quot;: 0</div>
<div class="line">            },</div>
<div class="line">            {</div>
<div class="line">                &quot;column&quot;: 3,</div>
<div class="line">                &quot;filterDp&quot;: &quot;_NgAsFilter_operator_4&quot;,</div>
<div class="line">                &quot;row&quot;: 0</div>
<div class="line">            }</div>
<div class="line">        ],</div>
<div class="line">        &quot;frameBackColor&quot;: &quot;none&quot;,</div>
<div class="line">        &quot;frameLineWidth&quot;: 2,</div>
<div class="line">        &quot;frameMidLineWidth&quot;: 1,</div>
<div class="line">        &quot;frameShadow&quot;: &quot;Raised&quot;,</div>
<div class="line">        &quot;frameShape&quot;: &quot;Box&quot;,</div>
<div class="line">        &quot;frameSpacing&quot;: 4,</div>
<div class="line">        &quot;itemBackColorSource&quot;: &quot;totalBg&quot;,</div>
<div class="line">        &quot;itemForeColorSource&quot;: &quot;none&quot;,</div>
<div class="line">        &quot;itemLineWidth&quot;: 2,</div>
<div class="line">        &quot;itemMidLineWidth&quot;: 1,</div>
<div class="line">        &quot;itemShadow&quot;: &quot;Raised&quot;,</div>
<div class="line">        &quot;itemShape&quot;: &quot;Panel&quot;,</div>
<div class="line">        &quot;itemTextFormat&quot;: &quot;%{name}: %{total} (%{notAck})&quot;,</div>
<div class="line">        &quot;itemToolTipTextFormat&quot;: &quot;%{name}: total %{total}, not acked %{notAck}&quot;</div>
<div class="line">    }</div>
<div class="line">}</div>
</div><!-- fragment --><p>Every element in filter view description in JSON directlt corresponds to one of elements in corresponding editor <a class="el" href="page_FilterViewEditor.html">panel</a>, so the meaning must be clear.</p>
<p>Few words about the root element <b>grid</b>. Two types of Filter View were foreseen: grid and tree. However, Filter View oarganised in tree is not implemented yet. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
